/// Contains macro for debug output.
/**
 * @file
 */

#ifndef _DEBUG_H
#define _DEBUG_H

#include "globals.h"

/// if defined debug is enabled
//#define DEBUG

#ifdef DEBUG 
/// Macro for debug print
#define dbgprint(format, args...) \
	do {            \
		printf("[%s %d]: "format"\n", __FUNCTION__, __LINE__, ## args);\
	} while ( 0 )
#else
#define dbgprint(format, args...) do {} while( 0 );
#endif

#endif
