/*
 *             foriana
 * 
 *  FOrensic Ram Image ANAlyzer
 *  written in 2007-2009 by niekt0
 *  (niekt0@hysteria.sk, https://hysteria.sk/~niekt0)
 *  (please, mail me any discovered bugs/improvements.)
 * 
 * 
 *  version 0.5.0
 * 
 *  newest version at https://hysteria.sk/~niekt0/foriana
 * 
 *  Under GNU GPL.
 *  See http://gnu.org for more information.
 * 
 *  Use at your own risk.
 * 
*/


/* Limits of this version:
   see TODO
 */

#include "globals.h"
//#include "search.h"
#include <arch/i386/functions.h>


/*
 *  Global variables
 */


struct my_image image1;

char helpstatusfile[256]="foriana.cache"; //this is dirty, but better than malloc a freeing
char *statusfile2,*statusfile=helpstatusfile;
FILE *fs=NULL;		//cache file

char *inputfile;	//filename
int inputfd,statusfd;	//input & status output 
FILE *f;		//separate descriptor for searching in file

struct stat sbuffer;
char *errormsg;

char tmp_small_page[VPT_MAGIC_BS];
char MAGIC_MODULE[MD_NAME_LEN]=LINUX_MAGIC_MODULE; // user can specify magic constants
char MAGIC_PROCESS[TS_COMM_LEN]=LINUX_MAGIC_PROCESS; //-||-
char MAGIC_USER_PROCESS[TS_COMM_LEN]=LINUX_MAGIC_USER_PROCESS; //-||-


int i,j,opt,mode=1,status=0,tmp;
unsigned long read_addr=0,size_read_addr=0,pgd_read_addr=0,single_process=0,single_module=0;
unsigned char *pointer;

int do_mod_list=0,do_mod_det=0,do_proc_det=0,do_proc_list=0; //for parsing cmdline options
int do_files_det=0,do_files_list=0,ignore_cache=0,ddebug=0; // -||-
//to save which foriana functionalities user requested

// Debug function
int debug(){
	int i;

	printf("--------- Begin of debug info ---------\n");
	printf("do_mod_list: %d,do_mod_det: %d,do_proc_det: %d,do_proc_list: %d,ignore_cache: %d\n",do_mod_list,do_mod_det,do_proc_det,do_proc_list,ignore_cache);
	printf("guest_block_size: %d\narchitecture: %s\noperating_system: %s\nVPT_address: %lx\nram_size: %llu\nts_hl_comm_dst: %d\nmd_hl_name_dst: %d\nts_one_of_lists: %lx\nts_hl_mm_dst: %d\nmm_pgd_dst: %d\n",
	image1.guest_block_size,	// size of block in analyzed image
	image1.architecture,	// hw architecture of analyzed image
	image1.operating_system,	// operation system if analyzed image
	image1.VPT_address,	// position of VPT (from beginning of file)
	image1.ram_size,	  // size of image in kilobytes
	image1.ts_hl_comm_dst,	  // distance between comm and headlist 
	image1.md_hl_name_dst,
	image1.ts_one_of_lists, // address of tasks list_head of one of taks_struct structures
	image1.ts_hl_mm_dst, // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	image1.mm_pgd_dst); // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!
	
	printf("ts_headlists_nuber:%d\n",image1.ts_headlists_number);
	for (i=TS_MAGIC_HEADLIST_MAX;i>=0;i--){
		printf("  Headlist number %d: %lx\n",i,image1.ts_headlists[i]);
	}
	
	printf("md_headlists_nuber:%d\n",image1.md_headlists_number);
	for (i=MD_MAGIC_HEADLIST_MAX;i>=0;i--){
		printf("  Headlist number %d: %lx\n",i,image1.md_headlists[i]);
	}
	printf("--------- End of debug info ---------\n");

	return 0;
}

/*
 * Function that saves gathered information into cachefile.
 * If you modify this function, don't forget to modify read_info too!
 * 
 */

int save_info(){
	int i;
	
	printf("Saving determined information to cache file. \n");

        if ( (fs = fopen(statusfile,"w")) == NULL ) {
		errormsg = strerror(errno);
		fprintf(stderr, "%s: %s.\n",statusfile,errormsg);
		return 22;
	}

	// So at this moment we have file open for writing

	
	i=fprintf(fs,"%d\n%s\n%s\n%lx\n%llu\n%d\n%d\n%lx\n%d\n%d\n%lx\n",
	image1.guest_block_size,	// size of block in analyzed image
	image1.architecture,	// hw architecture of analyzed image
	image1.operating_system,	// operation system if analyzed image
	image1.VPT_address,	// position of VPT (from beginning of file)
	image1.ram_size,	  // size of image in kilobytes
	image1.ts_hl_comm_dst,	  // distance between comm and headlist 
	image1.md_hl_name_dst,	// distance between name and headlist in module
	image1.ts_one_of_lists, // linear address of tasks list_head of one of taks_struct structures
	image1.ts_hl_mm_dst, // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	image1.mm_pgd_dst, // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!
	image1.md_one_of_lists); // linear address of module list_head of one of module structures
	
	i=fclose(fs);
	
	return i;
}

/*
 * Function that reads previously saved information from cachefile
 * If you modify this function, don't forget to modify save_info too!
 * 
 */

int read_info(){
	int i;

	printf("Looking for cache_file: \"%s\" ... ",statusfile);fflush(stdout);

        if ( (fs = fopen(statusfile,"r")) == NULL ) {
//		dbgprint("read_info: file does not exist.\n");fflush(stdout);
		return 1;	//file does not exists => we will perform determination
	}

	// So at this moment we have file open for reading

	
	i=fscanf(fs,"%d\n%s\n%s\n%lx\n%llu\n%d\n%d\n%lx\n%d\n%d\n%lx",
	&image1.guest_block_size,	// size of block in analyzed image
	image1.architecture,	// hw architecture of analyzed image
	image1.operating_system,	// operation system if analyzed image
	&image1.VPT_address,	// position of VPT (from beginning of file)
	&image1.ram_size,	  // size of image in kilobytes
	&image1.ts_hl_comm_dst,	  // distance between comm and headlist in task_struct
	&image1.md_hl_name_dst,	  // distance between name and headlist in module
	&image1.ts_one_of_lists, // address of tasks list_head of one of taks_struct structures
	&image1.ts_hl_mm_dst, // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	&image1.mm_pgd_dst, // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!
	&image1.md_one_of_lists); // linear address of module list_head of one of module structures

//	printf("read_info: elements: %d.\n",i);fflush(stdout);
	
	if (i != FORIANA_CACHE_SIZE){
		printf("read_info: %d elements: bad file format.\n",i);fflush(stdout);
		return 2;
	}	

	fclose(fs);
	printf("ok.\n");
	return 0;
}


/* 
 * Initialization function
 *
 * return > 0 if error occure
 * otherwise 0
 */

int init(){

//	printf("Init,%d, %s\n",inputfd,inputfile);

	//open input file	
        if ( (inputfd = open(inputfile,O_RDONLY)) == -1 ) {
                errormsg = strerror(errno);
                fprintf(stderr, "%s: %s.\n",inputfile,errormsg);
                return 21;
        }

//	printf("Init2:,%d\n",inputfd);

	//Determine file size
	if ( fstat(inputfd,&sbuffer) == -1){
		fprintf(stderr, "%s: Cannot get file statistics.\n",inputfile);
		return 22;
	}

	image1.ram_size=sbuffer.st_size;

	strcpy(image1.architecture,"NULL");
	strcpy(image1.operating_system,"NULL");

	//Check if we can read image "header"
	if (image1.ram_size < MB_1){	
		fprintf(stderr, "%s: File is too small (<1MB). Are you sure it is a memory dump? If yes, please modify foriana source code.\n",inputfile);
		return 23;
	}
	
	printf("Dumped RAM size is %llu MB.\n",image1.ram_size/MB_1);
	
	return 0;

}

void help(){
	
	printf("\nforiana %s by niekt0@hysteria.sk\n",fversion);
	printf("Usage: foriana [options] RAM_image\n");
	printf("Options:\n");
	printf("  -a/--all : try to dump everything available. Generally not good idea.\n");
	printf("  -c/--cache <file> : specify cache file with already determined information\n");
	printf("  --debug: development debug informations will be printed\n");
	printf("  -d/--determine-only : only determine information about image, do not list anything\n");
	printf("  --determine-skip-processes : skip determination of process structure\n");
	printf("  --determine-skip-modules : skip determination of module structure\n");
	printf("  --determine-skip-files : skip determination of various file structures\n");
	printf("  -h/--help : secret option\n");

	printf("  -i/--ignore-cache : ignores stored cache, and force new determination\n");

	printf("  --list-modules : force listing of modules\n");
	printf("  --list-processes : force listing of processes\n");
	printf("  --list-files : (NOT WORKING NOW) force listing of open files\n");
	printf("  --magic-module <name> : specify module name foriana is looking for (default: \"kthread\")\n");
	printf("  --magic-process <name> : specify process name foriana is looking for (default: \"yenta_socket\")\n");
	printf("  --magic-user-process <name> : specify process name foriana assumes first one (default: \"init\")\n");


	printf("  -m/--module <address> : list all information about this module only\n");
	printf("  -p/--process <address> : list all information about this process only\n");

	printf("  --pgd-read-linear <physical address of process page directory> : kernel PGD by default\n");
	printf("  --read-linear <linear address> : liner address to read size-read-linear bytes from\n");
	printf("  --size-read-linear <size in bytes> : for --read-linear\n");

	printf("  -v/--version : print version number\n");
}

int main(int argc, char **argv)
{	

	// get_parameters

	static struct option long_opts[]={
		{"all",0,0,'a'},    
		{"cache",1,0,'c'},    
		{"debug",0,0,248},
		{"determine",0,0,'d'},    
		{"determine-skip-processes",0,0,245},
		{"determine-skip-modules",0,0,246},
		{"determine-skip-files",0,0,247},
		{"help",0,0,'h'},
		{"ignore-cache",0,0,'i'},
		{"list-modules",0,0,240},
		{"list-processes",0,0,241},	
		{"list-files",0,0,249},
		{"module",1,0,'m'},
		{"magic-module",1,0,242},
		{"magic-process",1,0,243},
		{"magic-user-process",1,0,244},
//		{"output",1,0,'o'}, // decided to use stdout instead 
		{"process",1,0,'p'},
		{"pgd-read-linear",1,0,250},
		{"read-linear",1,0,'r'},
		{"size-read-linear",1,0,'s'},
//		{"specify",1,0,'s'},	//specify some advanced options
		{"version",0,0,'v'},
		{0,0,0,0}                             
	};



	while((opt = getopt_long(argc, argv, "ac:dhim:p:r:s:v",long_opts, &i)) != -1) {
//		printf("opt: %d\n",opt);
	  switch(opt) {
		case 'a': /*--all*/
			if (!(do_mod_det < 0)) {do_mod_det = 1; }
			if (!(do_mod_list < 0)) {do_mod_list = 1;}
			if (!(do_proc_det < 0)) {do_proc_det = 1;}
			if (!(do_proc_list < 0)) {do_proc_list = 1;}

			if (!(do_files_det < 0)) {do_files_det = 1;}
			if (!(do_files_list < 0)) {do_files_list = 1;}
			break;
		case 'c': /*--cache*/
			statusfile = optarg;
			break;
		case 248: /*--debug*/
			ddebug=1;
			break;
		case 'd': /*--determine*/
			if (!(do_mod_det < 0)) {do_mod_det = 1;}
			if (!(do_proc_det < 0)) {do_proc_det = 1;}
			if (!(do_files_det < 0)) {do_files_det = 1;}
			break;
		case 'h': help(); return 0; break;
		case 'i': ignore_cache=1; break; /*--ignore-cache*/
		case 'm': /*--module*/
	 		if (mode == 1) {mode=800; } else {mode=-800;} // --module is solo
			single_module=strtoul(optarg,NULL,16); //hexa
			break; 
//		case 'o': outputfile=optarg; break; // Using stdout instead
		case 'p':/*--process*/
	 		if (mode == 1) {mode=900; } else {mode=-900;} // --process is solo
			single_process=strtoul(optarg,NULL,16); //hexa
			break; 
		case 'r': /*--read-linear*/	
			if (mode == 1) {mode=700; } else {mode=-700;}
			read_addr=strtoul(optarg,NULL,16); //hexa
			break;
		case 's': /*--size-read-linear*/	
			size_read_addr=atol(optarg);
			break;
		case 250: /*--pgd-read-linear"*/
			pgd_read_addr=strtoul(optarg,NULL,16); //hexa
			break;
		case 240: /*list_modules*/
			do_mod_list=1;
			break;
		case 241: /*list-processes*/
			do_proc_list=1;
			break;
		case 249: /*list-files*/
			do_files_list=1; //1 XXX TODO not working right now ;
			break;
		case 242: /*--magic-module*/  
//			memcpy(MAGIC_MODULE,optarg,strlen(optarg)+1); //+1 because of \0
			strncpy(MAGIC_MODULE,optarg,MD_NAME_LEN);
			MAGIC_MODULE[MD_NAME_LEN -1]= '\0'; //to be sure
			printf("Using magic_module: %s\n",MAGIC_MODULE); //XXX DBG
			break;
		case 243: /*--magic-process*/
//			memcpy(MAGIC_PROCESS,optarg,strlen(optarg)+1); //+1 because of \0
			strncpy(MAGIC_PROCESS,optarg,TS_COMM_LEN);
			MAGIC_PROCESS[TS_COMM_LEN -1]= '\0'; //to be sure
			printf("Using magic_process: %s\n",MAGIC_PROCESS); //XXX DBG
			break;
		case 244: /*--magic-user-process*/
//			memcpy(MAGIC_USER_PROCESS,optarg,strlen(optarg)+1); //+1 because of \0
			strncpy(MAGIC_USER_PROCESS,optarg,TS_COMM_LEN);
			MAGIC_USER_PROCESS[TS_COMM_LEN -1]= '\0'; //to be sure
			printf("Using magic_user_process: %s\n",MAGIC_USER_PROCESS); //XXX DBG
			break;
		case 245: /*--determine-skip-processes*/ 
			do_proc_det=-1; // Conflict flag
			//	do_mod_list=-1; // No listing without determination? 
			// It's less user-friendly, but allow you to modify cache file by hand.
			break;
		case 246: /*--determine-skip-modules*/;
			do_mod_det=-1; // Conflict flag
			//	do_mod_list=-1; // No listing without determination? 
			// It's less user-friendly, but allow you to modify cache file by hand.
			break;
		case 247: /*determine-skip-files*/
			do_files_det=-1; // Conflict flag
			//	do_mod_list=-1; // No listing without determination? 
			// It's less user-friendly, but allow you to modify cache file by hand.
			break;

		case 'v': printf("foriana %s\n",fversion); return 0; break;
		case '?': fprintf(stderr, "Syntax error.\n"); help(); return 7; break;	
	  }   	
	}	

        if ((argv[optind] != NULL) && (argv[optind+1]==NULL)) {
                printf("Analyzing file %s\n",argv[optind]);
		inputfile = argv[optind];
        }else {
		fprintf(stderr, "Syntax error.\n"); 
		help();
		return 7;	
	}



	// parameter defaults
	
	/*
	 * Foriana check for cache file named "." + basename() of analysed image 
	 * inside working directory. If no cache file is found, new cache is
	 * created of this name. Name can be overridden with -c option.
	 *
	 */
	//dbgprint("statusfile0: %s\n",statusfile);fflush(stdout); //DBG
	if ( statusfile == helpstatusfile ) {	// cache file not specified
		
		//have to copy string before calling basename, according to man 3 basename
		if ( (statusfile2=strdup(inputfile) ) == NULL) {
			fprintf(stderr, "filename failed.\n");
			return 98;
		}	

//		if ( (statusfile=malloc(strlen(inputfile)+1)) == NULL) { //ble...
//			fprintf(stderr, "malloc() failed.\n");
//			return 99;
//		}

		snprintf(statusfile,256,".%s\0", basename(statusfile2)); //max cache filename size
		free(statusfile2);

	}

	// parameter collisions 

	/* Following parameter collisions are checked:
	 * - --ignore-cache, and --determine-skip-X and --list-X 
	 * - --read-linear and determine/list option
	 * - --process must be used solo
	 */
	
	if ((do_mod_det < 1) && (do_mod_list == 1) && (ignore_cache == 1))  {
		fprintf(stderr,"Parameter collision: Trying to list modules, but determined information not avaiable...exiting\n");
		return 13;
	}

	if ((do_proc_det < 1) && (do_proc_list == 1) && (ignore_cache == 1))  {
		fprintf(stderr,"Parameter collision: Trying to list processes, but determined information not avaiable...exiting\n");
		return 13;
	}

	if ((do_files_det < 1) && (do_files_list == 1) && (ignore_cache == 1))  {
		fprintf(stderr,"Parameter collision: Trying to list open files, but determined information not avaiable...exiting\n");
		return 13;
	}

	if ((mode > 1) && ((do_mod_list == 1) || (do_files_list == 1) || (do_proc_list == 1) 
	|| (do_mod_det == 1) || (do_files_det == 1) || (do_proc_det == 1)))  { //read_linear
		fprintf(stderr,"Parameter collision: some options must be used solo...exiting\n");
		return 13;
	}

	if ((mode == 700) && (size_read_addr == 0))  { //size_read_linear
		fprintf(stderr,"Parameter collision: size-read-linear not specified...exiting\n");
		return 13;
	}


	// ----------------- program starts here ---------------------
	
		

	//Check size of input file & initialize
	if ((i = init()) != 0) {
		printf("Init returned %d. Exiting.\n",i);
		return 1;
	}


	if (ddebug == 1 ) {debug(); } //DBG
	fflush(stdout);
	//Determine information only if ignore_cache is not set,
	// or if cache file is missing or invalid

	if ((ignore_cache > 0) || ((i = read_info()) != 0))
	{
		if (ignore_cache > 0) {
			printf("Ignoring cache file.\n");
		}else{
                	printf("no valid cache found (err %d).\n",i);
		}
        	

		//Determine general information from image (i386 architecture)
		if ((i = i386_lin_determine()) != 0) {
	                printf("Determine returned %d. Exiting.\n",i);
	                return 2;
	        }

		if ( do_proc_det > 0 ) {
			if ((i = i386_lin_linux_determine()) != 0) {
                		printf("Linux_determine returned %d. Exiting.\n",i);
                		return 3;
			}
        	}

		if ( do_mod_det > 0 ) {
			if ((i = i386_lin_linux_determine_module()) != 0) {
        	       		printf("Linux_determine_module returned %d. Exiting.\n",i);
                		return 4;
        		}
		}

		if ( do_files_det > 0 ) {
			printf("Determine open files: TODO (still bugy)\n");
//		        if ((i = i386_lin_determine_open_files(image1.ts_one_of_lists)) != 0) {
//				printf("i386_lin_determine_open_files returned %d. Exiting.\n",i);
//				return 6;
//			}
		}

		if ((i = save_info()) != 0) {
	                printf("save_info returned %d. Exiting.\n",i);
	                return 5;
	        }
		
		search_exit(); //for closing open file

//		if (ddebug == 1 ) {debug(); } //DBG

	}
	fflush(stdout);
	
	/* -p/--process <hex_addr>
	 * Display: 
	 * - process linear address
	 * - process physical address
	 * - process name
	 * - process PGD (for --read-linear)
	 * - list of open files for this process
	 */
	if (mode == 900) { // --process is solo
		// Put this into function (for multiple architectures))
		if (single_process == 0) {
			printf("Invalid process address.\n");
			return 902;
		}
	
		int status900=0;	
		unsigned long tmp901=0,tmp902=0,tmp903=0,tmp904=0;		
		unsigned char tmp900_comm[TS_COMM_LEN];

	        i386_lin_read_linear(0,single_process+image1.ts_hl_comm_dst,tmp900_comm,TS_COMM_LEN,&tmp901); //name
	        status900=i386_lin_read_linear(0,single_process+image1.ts_hl_mm_dst,&tmp902,POINTER_SIZE,NULL); //mm_struct
		if (status900 == 0 ) {i386_lin_read_linear(0,tmp902+image1.mm_pgd_dst,&tmp903,POINTER_SIZE,&tmp904);} //pgd

		printf("Detailed information about process at 0x%lx.\n",single_process);
                printf("Process linear address(in kernel context): 0x%lx\n",single_process); 
		printf("Process physical address(offset in dump): 0x%lx\n",tmp901);
		printf("Process name(short): \"%s\"\n",tmp900_comm);
		printf("Process PGD address(linear): 0x%lx\n",tmp902+image1.mm_pgd_dst);
		printf("Process PGD address(physical): 0x%lx\n",tmp904);
		printf("Process open files: TODO;)\n");
//              i386_lin_list_files(listhead); //list files for this process	//XXX
		
		return 0;	
	}

	/* -m/--module <hex_addr>
	 * Display: 
	 * - module address
	 * - module physical address
	 * - module name
	 * - ?
	 */
	if (mode == 800) { // --module is solo
		if (single_module == 0) {
			printf("Invalid module address.\n");
			return 802;
		}
		
		unsigned long tmp801=0;		
		unsigned char tmp800_comm[MD_NAME_LEN];

	        i386_lin_read_linear(0,single_module+image1.md_hl_name_dst,tmp800_comm,MD_NAME_LEN,&tmp801); 
		printf("Detailed information about module at 0x%lx.\n",single_module);
                printf("Module linear address(in kernel context): 0x%lx\n",single_module); 
		printf("Module physical address(offset in dump): 0x%lx\n",tmp801);
		printf("Module name(short): \"");
		int tmp802=0;
		for(;tmp802<=MD_NAME_LEN;tmp802++) {
			int tmp803=tmp800_comm[tmp802];
			if (isprint(tmp803) && ( tmp803 == ' ' || !isspace(tmp803)) ) {
			//only printable chars, but not end of lines, but yes space;)
			putc(tmp803,stdout);
			} else {
			putc('.',stdout); //non printable (in ascii)
			}
		}	//%s\"\n",tmp800_comm);
		printf("\"\n");	
		return 0;	
	}

	/* --read-linear <hex_addr>
	 * Display: 
	 * - linear address
	 * - physical address (first block)
	 * - hex dump
	 * - ascii dump (printable chars)
	 */
	if (mode == 700) { // read_linear is solo

		unsigned long tmp700=0;
		
		printf("Reading %lu bytes from linear address 0x%lx.\n",size_read_addr,read_addr);
		if ((pointer=(unsigned char *)malloc(size_read_addr)) == NULL) { // Not ideal solution for big blocks...
			fprintf(stderr, "malloc() failed.\n");
			return 724;
		}

		// if not specified, pgd_read_addr is 0 (kernel pgd)
		if ( (i = i386_lin_read_linear(pgd_read_addr,read_addr, pointer,size_read_addr,&tmp700) == -1 )) {
       	        	printf("--read-linear: 0x%lx seems is not valid virtual address.\n",read_addr);
			free(pointer);
    	       		return(723);
	       	} else {
			printf("Read %lu bytes from 0x%lx (physical address 0x%lx):\n",size_read_addr,read_addr,tmp700);
		}
		
		// now print block we have read
		printf("Hex dump & printable strings:\n");
		tmp=((LINE_SIZE/4)-1)& ~3; 
		//for each character, hexa number, (2 chars) space (1 char) and char itself (1 char) is printed
		//on standard 80 chars terminal, this makes 16 bytes per line
		
		//print loop
		printf("%lx: ",read_addr);
		for (i=0,j=0;i<size_read_addr;i++) {
			printf("%02x ",pointer[i]);
			j++;
			if ((j == tmp) || (i == size_read_addr-1)) { //end of line
				if (i == size_read_addr-1) { //special case: last line
					int tmp3=j;
					for (;tmp3<tmp;tmp3++) {printf("   ");} 
				}
				int i2=i-j+1;
				putc(' ',stdout);
				for(;i2<=i;i2++) {
					int tmp2=pointer[i2];
					if (isprint(tmp2) && ( tmp2 == ' ' || !isspace(tmp2)) ) {
					//only printable chars, but not end of lines, but yes space;)
						putc(tmp2,stdout);
					} else {
						putc('.',stdout); //non printable (in ascii)
					}
				}
				//printf("%d",i);
				printf("\n%lx: ",read_addr+i+1);
				j=0;
			}
		}	
		printf("End of hexdump.\n");	
		free(pointer);
		return 0;
	}

	//Listing stuff

	if ( do_proc_list > 0 ) {
		if ((i = i386_lin_list_processes(image1.ts_one_of_lists,image1.ts_hl_comm_dst)) != 0) {
        	        printf("Listed %d processes (hopefully).\n",i);
        	     //   return 4; //can fail
		}
        }

 	if ( do_mod_list > 0 ) {
		if ((i = i386_lin_list_modules(image1.md_one_of_lists,image1.md_hl_name_dst)) != 0) {
        	        printf("Listed %d modules (hopefully).\n",i);
	             //   return 4; //can fail
        	}
	}

 	if ( do_files_list > 0 ) {
		printf("List open files: TODO (not working)\n");
//		if ((i = i386_lin_list_files(image1.md_one_of_lists,image1.md_hl_name_dst)) != 0) {
//        	        printf("Listed %d open files (hopefully).\n",i);
//	             //   return 4; //can fail
//        	}
	}



// XXX small dirty sandbox
/*
        if ((i = i386_lin_determine_open_files(image1.ts_one_of_lists)) != 0) {
		printf("i386_lin_determine_open_files returned %d. Exiting.\n",i);
		return 666;
	}

	debug();
	
	if ((i = i386_lin_list_processes(image1.ts_one_of_lists,image1.ts_hl_comm_dst)) != 0) {
       	        printf("Listed %d processes (hopefully).\n",i);
       	     //   return 4; //can fail
	}

	if (ddebug == 1 ) {debug(); } //DBG
*/
	printf("Clean exit;).\n");
	//close output	
//	close(out_file);	
	return 0;

}
