#ifndef _STRUCTS_H
#define _STRUCTS_H

#include "arch/allarch.h"

struct my_image{	// information about file, we are adding
	int guest_block_size;	// size of block in analyzed image
	char architecture[32];	// hw architecture of analyzed image
	char operating_system[32];	// operation system if analyzed image
	unsigned long VPT_address;	// position of VPT (from beginig of file)
	unsigned long long ram_size;	  // size of image in kilobytes
	int ts_hl_comm_dst;	  // distance between comm and headlist fields in task_struct
	int md_hl_name_dst;	  // distance between name and headlist fields in module
	unsigned long ts_one_of_lists; // address of task list_head of one of taks_struct structures
	unsigned long md_one_of_lists; // address of list list_head of one of module structures
	int ts_hl_mm_dst; // =TS_MAGIC_HL_MM_DST; // Distance from "tasks" list_head to "mm" mmstruct...can vary!
	int mm_pgd_dst; // =MM_MAGIC_PGD_DST;  //Distance from beginning of mm_struct to pgd variable...can vary!

	int ts_headlists_number;  // how many headl_lists there are in task_struct before comm
	int md_headlists_number;  // how many headl_lists there are in module before name
	unsigned long ts_headlists[TS_MAGIC_HEADLIST_MAX]; // pointers to headlist of task_struct of one process
	unsigned long md_headlists[MD_MAGIC_HEADLIST_MAX]; // pointers to headlist of module

	// stuff for listing of open files:

// => task_struct ->  files   ->    fdt   ->  fd    ->  f_path  ->  mnt
//                (files_struct)  (fdtable)  (file **)   (path)   (vfsmount)
//                                                              ->  dentry -> d_name -> name
//                                                                 (dentry)   (qstr)  (char)

	int ts_hl_fs_dst;	//Distance from "tasks" list_head to "files" files_struct in task_struct
	int fs_fdt_dst;		//Distance from beginning of structure to "fdt" fdtable in files_struct
	int fdt_fd_dst;		//Distance from beginning of structure to "fd" **file in fdtable
	int fl_fpath_dst;	//Distance from beginning of structure to "f_path" path in file structure
	int pt_dentry_dst;	//Distance from beginning of structure to "dentry" dentry in path structure
	int dt_name_dst;	//Distance from beginning of structure to "d_name" qstr in dentry structure
	int qs_name_dst;	//Distance from beginning of structure to "name" *char in qstr. note: Should not change, this structure is elemental
	int fs_vfs_dst;		//Distance from beginning of structure to vfsmount in fs_struct.
	unsigned long one_of_paths;		//Pointer to one of path structs

};

#endif

